/*
 * Copyright (c) 2006-2021, RT-Thread Development Team
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Change Logs:
 * Date           Author       Notes
 * 2021-11-14     Administrator       the first version
 */

#include <rtthread.h>
#include "board.h"
#include "lcd/lcd.h"
#include "lcd/lcd_init.h"
#include "lcd/touch.h"

extern uint8_t watch_num;//ʾĴ

/* ƿ */
struct rt_mailbox touch_val_mb;
/* ڷʼڴ */
static char mb_pool[40];

uint16_t touch_val = 0;

void task_touch_scan(void *parameter)
{
    uint16_t lastpos[2];//һε
    lastpos[0]=0XFFFF;

    uint16_t i;

    while (1)
    {
//        if(TOUCH_READ() == PIN_LOW)
//        {
//            rt_kprintf("PEN = LOW\r\n");
//        }
        tp_dev.scan(0);//ɨ
        //rt_kprintf("scan...\r\n");
        if(tp_dev.sta&TP_PRES_DOWN)//а
        {
            //rt_kprintf("pen is down\r\n");
            rt_thread_mdelay(1);//Ҫʱ,Ϊа.

            if((tp_dev.x[0]<(LCD_W-1)&&tp_dev.x[0]>=1)&&(tp_dev.y[0]<(LCD_H-1)&&tp_dev.y[0]>=1))
            {
                switch(watch_num)
                {
                case 0://һ,ֻ1,2
                    if((tp_dev.x[0] > 0) && (tp_dev.x[0] < 4 * 16) &&
                       (tp_dev.y[0] > (LCD_H - 16)) && (tp_dev.y[0] < LCD_H))//ɾͼ
                    {
                        touch_val = 1;
                        rt_mb_send(&touch_val_mb, (void *)touch_val);
                    }
                    else if((tp_dev.x[0] > LCD_W - 16 *4) && (tp_dev.x[0] < LCD_W) &&
                            (tp_dev.y[0] > (LCD_H - 16)) && (tp_dev.y[0] < LCD_H))//ͼ
                    {
                        touch_val = 2;
                        rt_mb_send(&touch_val_mb, (void *)touch_val);
                    }
                    else if((tp_dev.x[0] > 20) && (tp_dev.x[0] < 110) &&
                            (tp_dev.y[0] > 35) && (tp_dev.y[0] < 150))//18
                    {
                        touch_val = 18;
                        rt_mb_send(&touch_val_mb, (void *)touch_val);
                    }
                    else if((tp_dev.x[0] > 130) && (tp_dev.x[0] < 220) &&
                            (tp_dev.y[0] > 35) && (tp_dev.y[0] < 150))//23
                    {
                        touch_val = 23;
                        rt_mb_send(&touch_val_mb, (void *)touch_val);
                    }

                    break;

                case 1://ڶļб,3~15
                    for(i = 0; i < 13; i++)
                    {
                        if((tp_dev.x[0] > 30) && (tp_dev.x[0] < LCD_W) &&
                           (tp_dev.y[0] > 30 + i * 20) && (tp_dev.y[0] < 50 + i * 20))
                        {
                            touch_val = (i + 3);
                            rt_mb_send(&touch_val_mb, (void *)touch_val);
                            break;
                        }
                    }
                    break;

                case 2:
                    if((tp_dev.x[0] > 40+2) && (tp_dev.x[0] < 62) &&
                       (tp_dev.y[0] > 200) && (tp_dev.y[0] < 220))//
                    {
                        touch_val = 16;
                        rt_mb_send(&touch_val_mb, (void *)touch_val);
                    }
                    else if((tp_dev.x[0] > 40+2) && (tp_dev.x[0] < 62) &&
                            (tp_dev.y[0] > 200-20) && (tp_dev.y[0] < 200))
                    {
                        touch_val = 17;
                        rt_mb_send(&touch_val_mb, (void *)touch_val);
                    }
                    break;

                case 3://Ķģʽ
                    if((tp_dev.x[0] > 0) && (tp_dev.x[0] < 120) &&
                       (tp_dev.y[0] > 20) && (tp_dev.y[0] < 160))//Ϸҳ
                    {
                        touch_val = 20;
                        rt_mb_send(&touch_val_mb, (void *)touch_val);
                    }
                    else if((tp_dev.x[0] > 120) && (tp_dev.x[0] < 240) &&
                            (tp_dev.y[0] > 20) && (tp_dev.y[0] < 160))//·ҳ
                    {
                        touch_val = 19;
                        rt_mb_send(&touch_val_mb, (void *)touch_val);
                    }
                    else if((tp_dev.x[0] > 0) && (tp_dev.x[0] < 240) &&
                            (tp_dev.y[0] > 260) && (tp_dev.y[0] < 320))//
                    {
                        touch_val = 21;
                        rt_mb_send(&touch_val_mb, (void *)touch_val);
                    }
                    break;
                case 4:
                    if((tp_dev.x[0] > 0) && (tp_dev.x[0] < 48) &&
                       (tp_dev.y[0] > 300) && (tp_dev.y[0] < 320))//
                    {
                        touch_val = 22;
                        rt_mb_send(&touch_val_mb, (void *)touch_val);
                    }
                    break;
                }
            }

//            if((tp_dev.x[0]<(LCD_W-1)&&tp_dev.x[0]>=1)&&(tp_dev.y[0]<(LCD_H-1)&&tp_dev.y[0]>=1))
//            {
//                if(lastpos[0]==0XFFFF)
//                {
//                    lastpos[0]=tp_dev.x[0];
//                    lastpos[1]=tp_dev.y[0];
//                }
//                LCD_DrawRoughLine(lastpos[0],lastpos[1],tp_dev.x[0],tp_dev.y[0],BLUE);//
//                lastpos[0]=tp_dev.x[0];
//                lastpos[1]=tp_dev.y[0];
//                LCD_ShowString(10,LCD_H-40,"X:",RED,WHITE,16,0);
//                LCD_ShowIntNum(26,LCD_H-40,tp_dev.x[0],3,RED,WHITE,16);
//                LCD_ShowString(10,LCD_H-20,"Y:",RED,WHITE,16,0);
//                LCD_ShowIntNum(26,LCD_H-20,tp_dev.y[0],3,RED,WHITE,16);
//            }
        }
        rt_thread_mdelay(300);
    }
}


int touch_scan(void)
{
    rt_thread_t tid;

    tid = rt_thread_create("touch scan", task_touch_scan, RT_NULL,
                           1024, RT_THREAD_PRIORITY_MAX - 10, 30);
    if (tid != RT_NULL)
    {
        rt_thread_startup(tid);
    }
    else
    {
        rt_kprintf("create touch_scan thread err!");
    }
    return RT_EOK;
}
//INIT_APP_EXPORT(touch_scan);


int touch_val_mailbox_init(void)
{
    rt_err_t result;

    /* ʼһ mailbox */
    result = rt_mb_init(&touch_val_mb,
                        "touch_mbt",                      /*  mbt */
                        &mb_pool[0],                /* õڴ mb_pool */
                        sizeof(mb_pool) / 4,        /* еʼĿΪһʼռ 4 ֽ */
                        RT_IPC_FLAG_FIFO);          /*  FIFO ʽ̵߳ȴ */
    if (result != RT_EOK)
    {
        rt_kprintf("init touch mailbox failed.\n");
        return -1;
    }

    return 0;
}
