/*
 * Copyright (c) 2006-2021, RT-Thread Development Team
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Change Logs:
 * Date           Author       Notes
 * 2021-10-31     Administrator       the first version
 */
#ifndef USER_LCD_LCD_INIT_H_
#define USER_LCD_LCD_INIT_H_

#include <rtthread.h>
#include "board.h"

#define USE_HORIZONTAL  1

#if USE_HORIZONTAL==0||USE_HORIZONTAL==1
#define LCD_W 240
#define LCD_H 320

#define MAX_HZ_POSX (LCD_W - 16)
#define MAX_HZ_POSY (LCD_H - 16)

#else
#define LCD_W 320
#define LCD_H 240
#endif

extern uint8_t lcd_clk;               //PE6
extern uint8_t lcd_mosi;              //PE1
extern uint8_t lcd_reset;             //PA1
extern uint8_t lcd_rs;                //PE7
extern uint8_t lcd_cs;                //PE0
extern uint8_t lcd_miso;              //PA0

extern uint8_t lcd_cs2;               //PE3
extern uint8_t lcd_pen;               //PE2

//-----------------LCD端口定义----------------

#define LCD_SCLK_Clr() rt_pin_write(lcd_clk, PIN_LOW)//SCL=SCLK
#define LCD_SCLK_Set() rt_pin_write(lcd_clk, PIN_HIGH)

#define LCD_MOSI_Clr() rt_pin_write(lcd_mosi, PIN_LOW)//SDA=MOSI
#define LCD_MOSI_Set() rt_pin_write(lcd_mosi, PIN_HIGH)

#define LCD_RES_Clr()  rt_pin_write(lcd_reset, PIN_LOW)//RES
#define LCD_RES_Set()  rt_pin_write(lcd_reset, PIN_HIGH)

#define LCD_DC_Clr()   rt_pin_write(lcd_rs, PIN_LOW)//DC
#define LCD_DC_Set()   rt_pin_write(lcd_rs, PIN_HIGH)

#define LCD_BLK_Clr()  //rt_pin_write(lcd_rs, PIN_LOW)//BLK
#define LCD_BLK_Set()  //rt_pin_write(lcd_res, PIN_HIGH)

#define LCD_CS_Clr()   rt_pin_write(lcd_cs, PIN_LOW)//CS1
#define LCD_CS_Set()   rt_pin_write(lcd_cs, PIN_HIGH)

#define LCD_CS2_Clr()   rt_pin_write(lcd_cs2, PIN_LOW)//CS2
#define LCD_CS2_Set()   rt_pin_write(lcd_cs2, PIN_HIGH)

#define LCD_READ()      rt_pin_read(lcd_miso)
#define TOUCH_READ()    rt_pin_read(lcd_pen)

void LCD_GPIO_Init(void);
void LCD_WR_DATA8(uint8_t dat);
void LCD_WR_DATA(uint16_t dat);
void LCD_WR_REG(uint8_t dat);
void LCD_Address_Set(uint16_t x1,uint16_t y1,uint16_t x2,uint16_t y2);
void LCD_Init(void);

#endif /* USER_LCD_LCD_INIT_H_ */
