/*
 * Copyright (c) 2006-2021, RT-Thread Development Team
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Change Logs:
 * Date           Author       Notes
 * 2021-11-14     Administrator       the first version
 */
#include "lcd/lcd_init.h"
#include "lcd/lcd.h"
#include "lcd/touch.h"
#include "math.h"
_m_tp_dev tp_dev=
{
    TP_Init,
    TP_Scan,
    TP_Adjust,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
};

#if USE_HORIZONTAL==0||USE_HORIZONTAL==1
uint8_t CMD_RDX=0XD0;
uint8_t CMD_RDY=0X90;

#else
uint8_t CMD_RDX=0X90;
uint8_t CMD_RDY=0XD0;
#endif

//SPIд
//ICд1byte
//num:Ҫд
//void TP_Write_Byte(uint8_t num)
//{
//    uint8_t count=0;
//    for(count=0;count<8;count++)
//    {
//        if(num&0x80)
//           LCD_MOSI_Set();
//        else
//            LCD_MOSI_Clr();
//        num<<=1;
//        LCD_SCLK_Clr();
//        rt_thread_mdelay(1);
//        LCD_SCLK_Set();     //Ч
//    }
//}

void TP_Write_Byte(uint8_t num)
{
    uint8_t count=0;
    for(count=0;count<8;count++)
    {
        LCD_SCLK_Clr();
        if(num&0x80)
           LCD_MOSI_Set();
        else
            LCD_MOSI_Clr();
        LCD_SCLK_Set();
        num<<=1;
    }
}

//SPI
//ӴICȡadcֵ
//CMD:ָ
//ֵ:
uint16_t TP_Read_AD(uint8_t CMD)
{
    uint8_t count=0;
    uint16_t Num=0;
    uint16_t temp=0;
//    LCD_SCLK_Clr();     //ʱ
//    LCD_MOSI_Clr();     //
    LCD_CS2_Clr();      //ѡдIC
    //for(temp = 100; temp > 0; temp--);
    TP_Write_Byte(CMD);//
    //for (temp = 400; temp > 0; temp--);
    //rt_thread_mdelay(1);//6
    LCD_SCLK_Clr();
    //rt_thread_mdelay(1);
    for(temp = 100; temp > 0; temp--);
    LCD_SCLK_Set();     //1ʱӣBUSY
//    rt_thread_mdelay(1);
//    LCD_SCLK_Clr();
    for(count=0;count<16;count++)//16λ,ֻи12λЧ
    {
        Num<<=1;
        LCD_SCLK_Clr();  //½Ч
        rt_thread_mdelay(1);
        LCD_SCLK_Set();
        if(LCD_READ())Num++;
    }
    Num>>=4;    //ֻи12λЧ.
    LCD_CS2_Set();      //ͷƬѡ
    return(Num);
}

//ȡһֵ(xy)
//ȡREAD_TIMES,Щ,
//ȻȥͺLOST_VAL,ȡƽֵ
//xy:ָCMD_RDX/CMD_RDY
//ֵ:
#define READ_TIMES 5    //ȡ
#define LOST_VAL 1      //ֵ
uint16_t TP_Read_XOY(uint8_t xy)
{
    uint16_t i, j;
    uint16_t buf[READ_TIMES];
    uint16_t sum=0;
    uint16_t temp;
    for(i=0;i<READ_TIMES;i++)
    {
        buf[i]=TP_Read_AD(xy);
        //rt_kprintf("buf[%d] = %d\r\n",i,buf[i]);
    }

    for(i=0;i<READ_TIMES-1; i++)//
    {
        for(j=i+1;j<READ_TIMES;j++)
        {
            if(buf[i]>buf[j])//
            {
                temp=buf[i];
                buf[i]=buf[j];
                buf[j]=temp;
            }
        }
    }
    sum=0;
    for(i=LOST_VAL;i<READ_TIMES-LOST_VAL;i++)sum+=buf[i];
    temp=sum/(READ_TIMES-2*LOST_VAL);
    return temp;
}

//ȡx,y
//Сֵ100.
//x,y:ȡֵ
//ֵ:0,ʧ;1,ɹ
uint8_t TP_Read_XY(uint16_t *x,uint16_t *y)
{
    uint16_t xtemp,ytemp;
    xtemp=TP_Read_XOY(CMD_RDX);
    ytemp=TP_Read_XOY(CMD_RDY);
    *x=xtemp;
    *y=ytemp;
    return 1;//ɹ
}
//2ζȡIC,εƫܳ
//ERR_RANGE,,Ϊȷ,.
//úܴ׼ȷ
//x,y:ȡֵ
//ֵ:0,ʧ;1,ɹ
#define ERR_RANGE 50 //Χ
uint8_t TP_Read_XY2(uint16_t *x,uint16_t *y)
{
    uint16_t x1,y1;
    uint16_t x2,y2;
    uint8_t flag;
    flag=TP_Read_XY(&x1,&y1);
    if(flag==0)return(0);
    rt_kprintf("x1 = %d,y1 = %d\r\n",x1,y1);
    flag=TP_Read_XY(&x2,&y2);
    if(flag==0)return(0);
    rt_kprintf("x2 = %d,y2 = %d\r\n",x2,y2);
    if(((x2<=x1&&x1<x2+ERR_RANGE)||(x1<=x2&&x2<x1+ERR_RANGE))//ǰβ+-50
    &&((y2<=y1&&y1<y2+ERR_RANGE)||(y1<=y2&&y2<y1+ERR_RANGE)))
    {
        *x=(x1+x2)/2;
        *y=(y1+y2)/2;
        return 1;
    }else return 0;
}

//////////////////////////////////////////////////////////////////////////////////
//LCDйصĺ
//һ
//У׼õ
//x,y:
//color:ɫ
void TP_Drow_Touch_Point(uint16_t x,uint16_t y,uint16_t color)
{
    LCD_DrawLine(x-12,y,x+13,y,color);//
    LCD_DrawLine(x,y-12,x,y+13,color);//
    LCD_DrawPoint(x+1,y+1,color);
    LCD_DrawPoint(x-1,y+1,color);
    LCD_DrawPoint(x+1,y-1,color);
    LCD_DrawPoint(x-1,y-1,color);
    Draw_Circle(x,y,6,color);//Ȧ
}

//һ(2*2ĵ)
//x,y:
//color:ɫ
void TP_Draw_Big_Point(uint16_t x,uint16_t y,uint16_t color)
{
    LCD_DrawPoint(x,y,color);//ĵ
    LCD_DrawPoint(x+1,y,color);
    LCD_DrawPoint(x,y+1,color);
    LCD_DrawPoint(x+1,y+1,color);
}

/******************************************************************************
      ˵
      ݣx1,y1   ʼ
                x2,y2   ֹ
                color   ߵɫ
      ֵ  
******************************************************************************/
void LCD_DrawRoughLine(uint16_t x1,uint16_t y1,uint16_t x2,uint16_t y2,uint16_t color)
{
    uint16_t t;
    int xerr=0,yerr=0,delta_x,delta_y,distance;
    int incx,incy,uRow,uCol;
    delta_x=x2-x1; //
    delta_y=y2-y1;
    uRow=x1;//
    uCol=y1;
    if(delta_x>0)incx=1; //õ
    else if (delta_x==0)incx=0;//ֱ
    else {incx=-1;delta_x=-delta_x;}
    if(delta_y>0)incy=1;
    else if (delta_y==0)incy=0;//ˮƽ
    else {incy=-1;delta_y=-delta_y;}
    if(delta_x>delta_y)distance=delta_x; //ѡȡ
    else distance=delta_y;
    for(t=0;t<distance+1;t++)
    {
        TP_Draw_Big_Point(uRow,uCol,color);//
        xerr+=delta_x;
        yerr+=delta_y;
        if(xerr>distance)
        {
            xerr-=distance;
            uRow+=incx;
        }
        if(yerr>distance)
        {
            yerr-=distance;
            uCol+=incy;
        }
    }
}
//////////////////////////////////////////////////////////////////////////////////
//ɨ
//tp:0,Ļ;1,(У׼ⳡ)
//ֵ:ǰ״̬.
//0,޴;1,д
uint8_t TP_Scan(uint8_t tp)
{
    if(TOUCH_READ()==0)//а
    {
        rt_kprintf("button down\r\n");
        if(tp)
        {
            TP_Read_XY2(&tp_dev.x[0],&tp_dev.y[0]);//ȡ
        }
        else if(TP_Read_XY2(&tp_dev.x[0],&tp_dev.y[0]))//ȡĻ
        {
            rt_kprintf("tp_dev.x[0] = %d,tp_dev.y[0] = %d\r\n",tp_dev.x[0],tp_dev.y[0]);
            tp_dev.x[0]=tp_dev.xfac*tp_dev.x[0]+tp_dev.xoff;//תΪĻ
            tp_dev.y[0]=tp_dev.yfac*tp_dev.y[0]+tp_dev.yoff;
            //rt_kprintf("")
        }
        if((tp_dev.sta&TP_PRES_DOWN)==0)//֮ǰûб
        {
            tp_dev.sta=TP_PRES_DOWN|TP_CATH_PRES;//
            tp_dev.x[4]=tp_dev.x[0];//¼һΰʱ
            tp_dev.y[4]=tp_dev.y[0];
        }
    }else
    {
        if(tp_dev.sta&TP_PRES_DOWN)//֮ǰǱµ
        {
            tp_dev.sta&=~(1<<7);//ǰɿ
        }else//֮ǰûб
        {
            tp_dev.x[4]=0;
            tp_dev.y[4]=0;
            tp_dev.x[0]=0xffff;
            tp_dev.y[0]=0xffff;
        }
    }
    return tp_dev.sta&TP_PRES_DOWN;//صǰĴ״̬
}

//У׼
//õĸУ׼
void TP_Adjust(void)
{
    uint16_t pos_temp[4][2];//껺ֵ
    uint8_t  cnt=0;
    uint16_t d1,d2;
    uint32_t tem1,tem2;
    double fac;
    cnt=0;
    LCD_Fill(0,0,LCD_W,LCD_H,WHITE);//
    LCD_ShowString(5,40,"Please adjustment the screen.",RED,WHITE,16,0);//ʾʾϢ
    TP_Drow_Touch_Point(20,20,RED);//1
    tp_dev.sta=0;//ź
    tp_dev.xfac=0;//xfacǷУ׼,У׼֮ǰ!
    while(1)//10ûа,Զ˳
    {
        tp_dev.scan(1);//ɨ
        if((tp_dev.sta&0xc0)==TP_CATH_PRES)//һ(ʱɿ.)
        {
            tp_dev.sta&=~(1<<6);//ǰѾ.

            pos_temp[cnt][0]=tp_dev.x[0];
            pos_temp[cnt][1]=tp_dev.y[0];
            cnt++;
            switch(cnt)
            {
                case 1:
                    TP_Drow_Touch_Point(20,20,WHITE);               //1
                    TP_Drow_Touch_Point(LCD_W-20,20,RED);   //2
                    break;
                case 2:
                    TP_Drow_Touch_Point(LCD_W-20,20,WHITE); //2
                    TP_Drow_Touch_Point(20,LCD_H-20,RED);   //3
                    break;
                case 3:
                    TP_Drow_Touch_Point(20,LCD_H-20,WHITE);         //3
                    TP_Drow_Touch_Point(LCD_W-20,LCD_H-20,RED); //4
                    break;
                case 4:  //ȫĸѾõ
                    //Ա
                    tem1=abs(pos_temp[0][0]-pos_temp[1][0]);//x1-x2
                    tem2=abs(pos_temp[0][1]-pos_temp[1][1]);//y1-y2
                    tem1*=tem1;
                    tem2*=tem2;
                    d1=sqrt(tem1+tem2);//õ1,2ľ

                    tem1=abs(pos_temp[2][0]-pos_temp[3][0]);//x3-x4
                    tem2=abs(pos_temp[2][1]-pos_temp[3][1]);//y3-y4
                    tem1*=tem1;
                    tem2*=tem2;
                    d2=sqrt(tem1+tem2);//õ3,4ľ
                    fac=(float)d1/d2;
                    if(fac<0.95||fac>1.05||d1==0||d2==0)//ϸ
                    {
                        cnt=0;
                    TP_Drow_Touch_Point(LCD_W-20,LCD_H-20,WHITE);   //4
                    TP_Drow_Touch_Point(20,20,RED);                             //1
                        LCD_ShowString(5,40,"Touch Adjust Filed!          ",RED,WHITE,16,0);//Уʧʾ
                        LCD_ShowString(5,60,"Please Adjust Again!         ",RED,WHITE,16,0);//Уʧʾ
                        rt_thread_mdelay(1000);
                        continue;
                    }
                    tem1=abs(pos_temp[0][0]-pos_temp[2][0]);//x1-x3
                    tem2=abs(pos_temp[0][1]-pos_temp[2][1]);//y1-y3
                    tem1*=tem1;
                    tem2*=tem2;
                    d1=sqrt(tem1+tem2);//õ1,3ľ

                    tem1=abs(pos_temp[1][0]-pos_temp[3][0]);//x2-x4
                    tem2=abs(pos_temp[1][1]-pos_temp[3][1]);//y2-y4
                    tem1*=tem1;
                    tem2*=tem2;
                    d2=sqrt(tem1+tem2);//õ2,4ľ
                    fac=(float)d1/d2;
                    if(fac<0.95||fac>1.05)//ϸ
                    {
                        cnt=0;
                    TP_Drow_Touch_Point(LCD_W-20,LCD_H-20,WHITE);   //4
                    TP_Drow_Touch_Point(20,20,RED);                             //1
                        LCD_ShowString(5,40,"Touch Adjust Filed!          ",RED,WHITE,16,0);//Уʧʾ
                        LCD_ShowString(5,60,"Please Adjust Again!         ",RED,WHITE,16,0);//Уʧʾ
                        rt_thread_mdelay(1000);
                        continue;
                    }//ȷ

                    //Խ
                    tem1=abs(pos_temp[1][0]-pos_temp[2][0]);//x1-x3
                    tem2=abs(pos_temp[1][1]-pos_temp[2][1]);//y1-y3
                    tem1*=tem1;
                    tem2*=tem2;
                    d1=sqrt(tem1+tem2);//õ1,4ľ

                    tem1=abs(pos_temp[0][0]-pos_temp[3][0]);//x2-x4
                    tem2=abs(pos_temp[0][1]-pos_temp[3][1]);//y2-y4
                    tem1*=tem1;
                    tem2*=tem2;
                    d2=sqrt(tem1+tem2);//õ2,3ľ
                    fac=(float)d1/d2;
                    if(fac<0.95||fac>1.05)//ϸ
                    {
                        cnt=0;
                    TP_Drow_Touch_Point(LCD_W-20,LCD_H-20,WHITE);   //4
                    TP_Drow_Touch_Point(20,20,RED);                             //1
                        LCD_ShowString(5,40,"Touch Adjust Filed!          ",RED,WHITE,16,0);//Уʧʾ
                        LCD_ShowString(5,60,"Please Adjust Again!         ",RED,WHITE,16,0);//Уʧʾ
                        rt_thread_mdelay(1000);
                            continue;
                    }//ȷ
                    //
                    tp_dev.xfac=(float)(LCD_W-40)/(pos_temp[1][0]-pos_temp[0][0]);//õxfac
                    tp_dev.xoff=(LCD_W-tp_dev.xfac*(pos_temp[1][0]+pos_temp[0][0]))/2;//õxoff

                    tp_dev.yfac=(float)(LCD_H-40)/(pos_temp[2][1]-pos_temp[0][1]);//õyfac
                    tp_dev.yoff=(LCD_H-tp_dev.yfac*(pos_temp[2][1]+pos_temp[0][1]))/2;//õyoff

                    TP_Drow_Touch_Point(LCD_W-20,LCD_H-20,WHITE);   //4
                    LCD_ShowString(5,40,"Touch Screen Adjust OK!      ",RED,WHITE,16,0);//У
                    LCD_ShowString(5,60,"                             ",RED,WHITE,16,0);//
                    rt_thread_mdelay(1000);
                    LCD_ShowString(5,40,"                       ",RED,WHITE,16,0);//
                    return;//У
            }
        }
    }
}
//ʼ
uint8_t TP_Init(void)
{
    uint8_t fac[20];
    if(Adujust)
    {
        if(USE_HORIZONTAL==0)
        {//***βͬԭĬϵУ׼ֵܻʶ׼У׼ʹãʹù̶ĬУ׼
            tp_dev.xfac=0.0651714;
            tp_dev.xoff=-13;
            tp_dev.yfac=0.087914;
            tp_dev.yoff=-10;
        }else if(USE_HORIZONTAL==1)
        {//***βͬԭĬϵУ׼ֵܻʶ׼У׼ʹãʹù̶ĬУ׼
            tp_dev.xfac=-0.065585;
            tp_dev.xoff=254;
            tp_dev.yfac=-0.090211;
            tp_dev.yoff=334;
        }else if(USE_HORIZONTAL==2)
        {//***βͬԭĬϵУ׼ֵܻʶ׼У׼ʹãʹù̶ĬУ׼
            tp_dev.xfac=0.089750;
            tp_dev.xoff=-14;
            tp_dev.yfac=-0.064668;
            tp_dev.yoff=251;
        }else
        {//***βͬԭĬϵУ׼ֵܻʶ׼У׼ʹãʹù̶ĬУ׼
            tp_dev.xfac=-0.088703;
            tp_dev.xoff=332;
            tp_dev.yfac=0.065260;
            tp_dev.yoff=-12;
        }
        return 0;
    }else
    {
        TP_Adjust();//ĻУ׼
        //У׼ʾLCDϣĬϲ׼ֶУ޸
        sprintf((char*)fac,"tp_dev.xfac:%10.6f",tp_dev.xfac);
        LCD_ShowString(10,LCD_H-140,fac,RED,WHITE,16,0);
        sprintf((char*)fac,"tp_dev.xoff:%d",tp_dev.xoff);
        LCD_ShowString(10,LCD_H-120,fac,RED,WHITE,16,0);
        sprintf((char*)fac,"tp_dev.yfac:%10.6f",tp_dev.yfac);
        LCD_ShowString(10,LCD_H-100,fac,RED,WHITE,16,0);
        sprintf((char*)fac,"tp_dev.yoff:%d",tp_dev.yoff);
        LCD_ShowString(10,LCD_H-80,fac,RED,WHITE,16,0);
        return 1;
    }
}


