/*
 * Copyright (c) 2020-2021, Bluetrum Development Team
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Change Logs:
 * Date           Author       Notes
 * 2020/12/10     greedyhao    The first version
 */

/**
 * Notice!
 * All functions or data that are called during an interrupt need to be in RAM.
 * You can do it the way exception_isr() does.
 */

#include <rtthread.h>
#include "board.h"
#include "lcd/lcd.h"
#include "lcd/lcd_init.h"
#include "picture/piclib.h"
extern int display_start(void);
extern int ab32_sdcard_mount(void);
extern int touch_scan(void);
extern int touch_val_mailbox_init(void);
int main(void)
{
    //rt_thread_mdelay(2000);
    ab32_sdcard_mount();
    rt_thread_mdelay(100);
    touch_val_mailbox_init();//ʼtouch
    touch_scan();
    display_start();
    while (1)
    {
        rt_thread_mdelay(1000);
    }
}
